Skip to content
DocsOpenAPI spec

    Create Bucket

    POST/v1/storage/buckets

    Create a Bucket. The Bucket is created asynchronously: follow the returned operation until it is done.

    Body ParametersJSONExpand Collapse
    name: string

    Name of the Bucket, used to address it over S3. It must be 3 to 63 characters of lowercase letters, digits, dots and hyphens, start and end with a letter or digit, not contain two adjacent dots and not be formatted as an IP address. “admin” and “ops-api” are reserved. The name cannot be changed once the Bucket is created.

    maxLength63
    minLength3
    project_id: string

    Project ID the Bucket belongs to.

    region: RegionName

    Region the resource is in.

    One of the following:
    "us-sva-2"
    "us-wdc-1"
    tags: optional array of string

    Tags to attach to the Bucket.

    ReturnsExpand Collapse
    Operation object { id, created_at, details, 6 more }

    Operation details.

    id: string

    Unique identifier for the Operation.

    created_at: string

    When the Operation was created.

    formatdate-time
    details: OperationDetails { changes }

    Structured details about what an operation is changing.

    changes: OperationChanges { from, to }

    Map of changed field names to their from/to diffs. Keys depend on the parent operation’s kind+type.

    from: string or number or boolean or array of string

    Previous value.

    One of the following:
    string
    number
    boolean
    array of string
    to: string or number or boolean or array of string

    New value.

    One of the following:
    string
    number
    boolean
    array of string

    Kind of Operation.

    One of the following:
    "vm"
    "volume"
    "vpc"
    "firewall_rule"
    "nks_cluster"
    "nks_node_pool"
    "sandbox_cluster"
    "bucket"
    project_id: string

    Project ID the Operation belongs to.

    resource_id: string

    ID of the resource that the Operation is acting on.

    Status of the Operation.

    One of the following:
    "pending"
    "running"
    "done"
    "failed"
    "unknown"

    Type of Operation.

    One of the following:
    "create"
    "update"
    "delete"
    "restart"
    updated_at: string

    When the Operation was updated.

    formatdate-time

    Create Bucket

    curl https://api.nirvanalabs.io/v1/storage/buckets \
        -H 'Content-Type: application/json' \
        -H "Authorization: Bearer $NIRVANA_LABS_API_KEY" \
        -d '{
              "name": "my-bucket",
              "project_id": "123e4567-e89b-12d3-a456-426614174000",
              "region": "us-sva-2",
              "tags": [
                "production",
                "ethereum"
              ]
            }'
    {
      "id": "123e4567-e89b-12d3-a456-426614174000",
      "created_at": "2025-01-01T00:00:00Z",
      "details": {
        "changes": {
          "foo": {
            "from": "string",
            "to": "string"
          }
        }
      },
      "kind": "vm",
      "project_id": "123e4567-e89b-12d3-a456-426614174000",
      "resource_id": "123e4567-e89b-12d3-a456-426614174000",
      "status": "pending",
      "type": "create",
      "updated_at": "2025-01-01T00:00:00Z"
    }
    Returns Examples
    {
      "id": "123e4567-e89b-12d3-a456-426614174000",
      "created_at": "2025-01-01T00:00:00Z",
      "details": {
        "changes": {
          "foo": {
            "from": "string",
            "to": "string"
          }
        }
      },
      "kind": "vm",
      "project_id": "123e4567-e89b-12d3-a456-426614174000",
      "resource_id": "123e4567-e89b-12d3-a456-426614174000",
      "status": "pending",
      "type": "create",
      "updated_at": "2025-01-01T00:00:00Z"
    }